/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package training;

import gibbs.GibbsSampler;
import data.DataPaths;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
/**
 *
 * @author Liangzhe
 */
public class CallGibbsSampler {
    //Model parameters
    //public static int Z=20;//number of topics
    //public static int K=20;//number of communities
    //Gibss sampling parameters
    //public static int n_itr=10;//number of iterations in the gibbs sampling
    //public static int burn_in=280;//burn in iterations
    public static int sam_interval=10;//interval of sampling all the variables
    public static int likelihood_interval=10;//interval of calculating the likelihood
    public static double tor=0.1;//the bias added from the labels;
    public static double discount=0.1;
    public static String link_sep="\t";//seperator used in reading the edges.txt
    //public static int n_runs=3;//number of times to run the gibbs sampling
    //public static int start_rid=1;//the starting run id
    
    public static void training(int n_runs,int start_rid, String save_dir,String network_file,String doc_file,int n_threads, int Z, int K, int NIT, int BURNIN) throws InterruptedException, FileNotFoundException, IOException{
        for(int i=0;i<n_runs;i++){
            long startTime=System.currentTimeMillis();
            DataPaths.save_dir=save_dir;
            DataPaths.network_file=network_file;
	    DataPaths.document_file=doc_file;
            ReadData rd=new ReadData(link_sep);
            rd.readData();
            GibbsSampler gs=new GibbsSampler();
            String s_dir=DataPaths.save_dir+"run"+(i+start_rid)+"/";
            gs.setup(
                    n_threads,
                    i+start_rid,
                    rd.users,
                    rd.user_map_back,
                    rd.word_map_back,
                    rd.word_map.size(),
                    rd.user_map.size(),
                    K,
                    Z,
                    //n_itr,
		    NIT,
                    //burn_in,
		    BURNIN,
                    sam_interval,
                    likelihood_interval,
                    tor,
                    discount,
                    s_dir);
            gs.run();
            long endTime=System.currentTimeMillis();
            System.out.println("Running time: "+(endTime-startTime)/1000+" secs.");
	    File file=new File(s_dir);
	    if (!file.exists()){
		    file.mkdirs();
	    }
            String filename=s_dir+"runningTime.txt";
            OutputStreamWriter out_f=new OutputStreamWriter(
            new FileOutputStream(new File(filename)));
            out_f.write(String.valueOf((endTime-startTime)/1000));
            out_f.flush();
            out_f.close();
        }
    }
}
