/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package training;
import java.util.HashMap;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import data.*;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
/**
 *
 * @author Liangzhe
 */
public class ReadData {
    public HashMap<String,Integer> user_map=new HashMap<String,Integer>();
    public HashMap<Integer,String> user_map_back=new HashMap<Integer,String>();
    public HashMap<String,Integer> word_map=new HashMap<String,Integer>();
    public HashMap<Integer,String> word_map_back=new HashMap<Integer,String>();
    public HashMap<Integer,User> users=new HashMap<Integer,User>();
    public static String link_sep;
    
    public ReadData(String link_sep){
        this.link_sep=link_sep;
    }
    public void readData(){
        System.out.println("read vocabulary");
        readVocab(DataPaths.vocab_file);
        //System.out.println("read users");
        //readUser(user_map,DataPaths.documents_dir);
        System.out.println("read documents");
        readDoc(DataPaths.document_file);
        save_maps();
        //System.out.println("read labels");
        //readLabels(DataPaths.label_dir);
        System.out.println("read network");
        readNet(DataPaths.network_file);
    }
    public void save_maps(){
        try{
            File file=new File(DataPaths.save_dir);
            if(!file.exists()){
                file.mkdirs();
            }
            String filename=DataPaths.save_dir+"user_map.txt";
            OutputStreamWriter out_f=new OutputStreamWriter(
            new FileOutputStream(new File(filename)));
            for(String name:user_map.keySet()){
                out_f.write(name+"\t"+user_map.get(name)+"\n");
            }
            out_f.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    public void readDoc(String in_file){
        int uid=0;
        try{
            BufferedReader br=new BufferedReader(new InputStreamReader (
                new FileInputStream(in_file),"UTF8"));
            String line=br.readLine();
            line=br.readLine();//ignore the first line with column names
            while(line!=null){
                String[] items=line.split("\t");
                String uname=items[0];
                if(!user_map.containsKey(uname)){
                    user_map.put(uname,uid);
                    user_map_back.put(uid, uname);
                    users.put(uid, new User(uid));
                    uid++;
                    if (uid%10000==0){
                        System.out.print(".");
                        if(uid%500000==0){
                            System.out.print("\n");
                        }
                    }
                }
                String[] words=items[2].split(" ");
                Document new_doc=new Document();
                String rt=items[3];
                new_doc.l=Integer.parseInt(rt);
                for(int i=0;i<words.length;i++){
		    if (word_map.containsKey(words[i])){
                    	int wid=word_map.get(words[i]);
                    	Word new_word=new Word(wid);
                    	new_doc.addWord(new_word);
		    }
                }
                users.get(user_map.get(uname)).addDoc(new_doc);
                line=br.readLine();
            }
            br.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    public void readNet(String in_file){
        try{
            int count=0;
            BufferedReader br=new BufferedReader(new InputStreamReader (
                new FileInputStream(in_file),"UTF8"));
            String line=br.readLine();
            while(line!=null){
                String[] items=line.split(link_sep);
                if (!user_map.containsKey(items[0]) || !user_map.containsKey(items[1])){
                    line=br.readLine();
                    continue;
                }
                int s=user_map.get(items[0]);
                int t=user_map.get(items[1]);
                Link new_link=new Link(s,t);
                users.get(s).addLink(new_link);
                count++;
                if (count%10000==0)System.out.print(".");
                if (count%500000==0)System.out.print("\n");
                line=br.readLine();
            }
            System.out.println("num_links:"+count);
            br.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    public void readLabels(String in_dir){
        int count=0;
        for(String name:user_map.keySet()){
            User curUser=users.get(user_map.get(name));
            try{
                BufferedReader br=new BufferedReader(new InputStreamReader (
                    new FileInputStream(in_dir+name),"UTF8"));
                String line=br.readLine();
                while(line!=null){
                    String[] items=line.split("\t");
                    if(items[1].equals("0")){
                        curUser.docs.get(Integer.parseInt(items[0])).l=Integer.parseInt(items[1]);
                    }
                    line=br.readLine();
                }
            }catch(Exception e){
                e.printStackTrace();
            }
            count++;
            if (count%10000==0)System.out.print(".");
            if (count%500000==0)System.out.print("\n");
        }
    }
    public void readDocs(String in_dir){
        int count=0;
        for(String name:user_map.keySet()){
            int uid=user_map.get(name);
            User new_user=new User(uid);
            try{
                BufferedReader br=new BufferedReader(new InputStreamReader (
                    new FileInputStream(in_dir+name),"UTF8"));
                String line=br.readLine();
                while(line!=null){
                    String document=line.split("\t")[1];
                    String[] words=document.split(" ");
                    Document new_doc=new Document();
                    for(int i=0;i<words.length;i++){
                        int wid=word_map.get(words[i]);
                        Word new_word=new Word(wid);
                        new_doc.addWord(new_word);
                    }
                    new_user.addDoc(new_doc);
                    line=br.readLine();
                }
                users.put(uid, new_user);
                br.close();
            }catch(Exception e){
                e.printStackTrace();
            }
            count++;
            if (count%10000==0)System.out.print(".");
            if (count%500000==0)System.out.print("\n");
        }
    }
    public static void readUser(HashMap<String,Integer> user_map,String in_dir){
        File f=new File(in_dir);
        File[] listOfFiles=f.listFiles();
        int uid=0;
        for (int i=0;i<listOfFiles.length;i++){
            String fname=listOfFiles[i].getName();
            if (listOfFiles[i].isFile() && fname.substring(0,1)!="."){
                user_map.put(fname, uid);
                uid++;
            }
        }
    }
    public void readVocab(String in_file){
        try{
            BufferedReader br=new BufferedReader(new InputStreamReader (
                    new FileInputStream(in_file),"UTF8"));
            String line=br.readLine();
            int wid=0;
	    String[] stopwords = {"rt", "rts", "*", "{", "}", "i'd", "im", "u",
	    "gonna", "wanna", "/", "lmao", "lol", "!!!", "''", "::", ":", "((",
	    "))", "(", ")", "[", "]", ".", ",", "fuck", "i'm", "i'v"};
            while(line!=null){
		//System.out.println(line);
		if(line.substring(0,1).equals("@")){
			line=br.readLine();
			continue;
		}
		int flag = 0;
		for (int i = 0; i < stopwords.length; i++){
			if (line.equals(stopwords[i])){
				line=br.readLine();
				flag = 1;
				break;
			}
		}
		if (flag == 1){
			continue;
		}
		if (line.length()>=4){
			if (line.substring(0,4).equals("http")){
				line=br.readLine();
				continue;
			}
		}
                word_map.put(line,wid);
                word_map_back.put(wid,line);
                wid++;
                line=br.readLine();
            }
            br.close();
        }catch(Exception e){
            e.printStackTrace();
        }
    }
}
