/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package utility;
import java.util.Random;
import org.apache.commons.math3.distribution.BetaDistribution;

/**
 *
 * @author Liangzhe
 */
public class Tools {
    public Random random;
    public Tools(){
        random=new Random();
    }
    public int sample_multi(double[] p){
        for(int i=1;i<p.length;i++){
            p[i]+=p[i-1];
        }
        if (p[p.length - 1] == 0){
            return random.nextInt(p.length);
        }else{
            double ran=random.nextDouble()*p[p.length-1];
            for (int i=0;i<p.length;i++){
                if(ran<p[i]){
                    return i;
                }
            }
            return p.length - 1;
        }
        //return p.length-1;
    }
    public int sample_multi_log(double[] p) {
        double max_value = -Double.MAX_VALUE;
        for (int i = 0; i < p.length; i++) {
            if (p[i] > max_value) {
                max_value = p[i];
            }
        }
        for (int i = 0; i < p.length; i++) {
            p[i] = Math.pow(Math.E, p[i] - max_value);
        }
        return sample_multi(p);
    }
    public int sample_binomial(double p){
        double[] new_p={p,1-p};
        return sample_multi(new_p);
    }
    public double sample_beta(double a,double b){
        BetaDistribution beta=new BetaDistribution(a,b);
        return beta.sample();
    }
    public double[] normalize(double[] p){
        double s=0.0;
        for (int i=0;i<p.length;i++){
            s+=p[i];
        }
        for (int i=0;i<p.length;i++){
            p[i]=p[i]/s;
        }
        return p;
    }
    public double[][] normalize(double[][] p){
        double s;
        for(int i=0;i<p.length;i++){
            s=0.0;
            for (int j=0;j<p[i].length;j++){
                s+=p[i][j];
            }
            for (int j=0;j<p[i].length;j++){
                p[i][j]=p[i][j]/s;
            }
        }
        return p;
    }
    public int choice(int n){
        return random.nextInt(n);
    }
}
